unit multiplepagesfound;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Grids, StdCtrls, ComCtrls,feeds,linklabel;

type
  TfrmMultiplePagesFound = class(TForm)
    pnlTop: TPanel;
    lblHeading: TLabel;
    sgArticles: TStringGrid;
    Splitter1: TSplitter;
    pnlContent: TPanel;
    txtContents: TMemo;
    pnlHyperlink: TPanel;
    pnlBottom: TPanel;
    btnClose: TButton;
    Splitter2: TSplitter;
    pnlFeedback: TPanel;
    lblTotallyRelevant: TLabel;
    lblIrrelevant: TLabel;
    lblRateHeading: TLabel;
    gbRelevance: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    RadioButton7: TRadioButton;
    RadioButton8: TRadioButton;
    RadioButton9: TRadioButton;
    RadioButton10: TRadioButton;
    RadioButton11: TRadioButton;
    RadioButton12: TRadioButton;
    RadioButton13: TRadioButton;
    RadioButton14: TRadioButton;
    RadioButton15: TRadioButton;
    RadioButton16: TRadioButton;
    RadioButton17: TRadioButton;
    RadioButton18: TRadioButton;
    RadioButton19: TRadioButton;
    RadioButton20: TRadioButton;
    RadioButton21: TRadioButton;
    Label1: TLabel;
    Label5: TLabel;
    btnShowRelevance: TButton;
    pnlArticleGridButtons: TPanel;
    pnlArticlesGridButtonsFixed: TPanel;
    btnFirst: TButton;
    Button1: TButton;
    btnNext: TButton;
    btnLast: TButton;
    procedure FormCreate(Sender: TObject);
    procedure sgArticlesSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure RadioButton1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure btnShowRelevanceClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure btnFirstClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure btnNextClick(Sender: TObject);
    procedure btnLastClick(Sender: TObject);
  private
    { Private declarations }
    frmFeeds: TForm;
    cellChanging: boolean;
    articles: Items;
    linkLabel: TLinkLabel;
    procedure layout;
    procedure showArticle(index: integer);
    function getRelevance: integer;
    procedure setRelevance(relevance: integer);
  public
    { Public declarations }
    procedure setFeedsForm(_frmFeeds: TForm);
    procedure addArticles(var _articles: Items);
  end;

const
   COLUMN_TITLE = 0;
   COLUMN_REASON = 1;
   COLUMN_USER_RATING = 2;

var
  frmMultiplePagesFound: TfrmMultiplePagesFound;

implementation

uses main;

{$R *.dfm}

procedure TfrmMultiplePagesFound.setFeedsForm(_frmFeeds: TForm);
begin
   frmFeeds := _frmFeeds;
end;


procedure TfrmMultiplePagesFound.btnFirstClick(Sender: TObject);
begin
   sgArticles.Row := 1;
end;

procedure TfrmMultiplePagesFound.btnLastClick(Sender: TObject);
begin
   sgArticles.Row := sgArticles.RowCount - 1;
end;

procedure TfrmMultiplePagesFound.btnNextClick(Sender: TObject);
begin
   if sgArticles.Row < sgArticles.Rowcount-1 then
      sgArticles.Row := sgArticles.Row + 1;
end;

procedure TfrmMultiplePagesFound.btnShowRelevanceClick(Sender: TObject);
var
   wordsList: TStringList;
   frmFeedsCasted: TfrmFeeds;
   words: string;
begin
   Screen.Cursor := crHourglass;
   frmFeedsCasted := (frmFeeds as TfrmFeeds);
   words := sgArticles.Cells[COLUMN_TITLE,sgArticles.Row] + ' ' + txtContents.text;
   wordsList := frmFeedsCasted.getCleanWordList(words);
   try
      showmessage('Simple relevance='+inttostr(frmFeedsCasted.checkSimpleRelevance(wordsList))+'%, ' +
         'Relationship relevance='+inttostr(frmFeedsCasted.checkRelevanceInRelTable(wordsList))+'%, ' +
         'Overall relevance='+inttostr(frmFeedsCasted.checkRelevance(words))+'%');
   finally
      wordsList.free;
      Screen.Cursor := crDefault;
   end;
end;

procedure TfrmMultiplePagesFound.Button1Click(Sender: TObject);
begin
   if sgArticles.Row > 1 then
      sgArticles.Row := sgArticles.Row - 1;
end;

procedure TfrmMultiplePagesFound.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
var
   i,rated: integer;
begin
   CanClose := true;
   rated := 0;
   for i := 0 to length(articles) - 1 do
   begin
      if articles[i].relevanceRatingFromUser <> 0 then
         inc(rated);
   end;

   if (showNagScreens) and (length(articles) > 1) and (rated <= length(articles) div 3) then
   begin
      if MessageDlg('You have only rated ' + IntToStr(rated) + '/' + IntToStr(length(articles)) + ' articles.' + chr(13)+chr(10) +
         'If you do not rate articles, I cannot learn about your interests.' + chr(13)+chr(10) + chr(13)+chr(10) +
         'Do you wish to close the page anyway and leave the other articles unrated?', mtConfirmation, [mbYes, mbNo], 0) = mrNo then
      begin
         CanClose := false;
      end;
   end;
end;

procedure TfrmMultiplePagesFound.FormCreate(Sender: TObject);
begin
   sgArticles.Cells[COLUMN_TITLE,0] := 'Title';
   sgArticles.Cells[COLUMN_REASON,0] := 'Reason';
   sgArticles.Cells[COLUMN_USER_RATING,0] := 'Your rating';
end;


procedure TfrmMultiplePagesFound.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   // note - form's "KeyPreview" must be set to true or this event isn't fired
   btnShowRelevance.visible := ((ssShift in Shift) and (ssAlt in Shift));
end;

procedure TfrmMultiplePagesFound.FormResize(Sender: TObject);
begin
   sgArticles.ColWidths[COLUMN_TITLE] := self.Width div 2;
   sgArticles.ColWidths[COLUMN_REASON] := self.Width div 4;
   sgArticles.ColWidths[COLUMN_USER_RATING] := self.Width div 4;
end;

procedure TfrmMultiplePagesFound.addArticles(var _articles: Items);
begin
   articles := _articles;
   assert(length(articles) > 0);

   lblHeading.Caption := 'Found ' + IntToStr(length(articles)) + ' articles, displaying in order of relevance';

   linkLabel := TLinkLabel.create(self);
   with linkLabel do
   begin
      parent := pnlHyperlink;
      top := 10;
      left := 10;
      visitedColor := clBlue;
      show;
   end;

   layout;
end;


procedure TfrmMultiplePagesFound.layout;
var
   i: integer;
begin
   sgArticles.RowCount := length(articles)+1;
   for i := 0 to length(articles) - 1 do
   begin
      sgArticles.Cells[COLUMN_TITLE,i+1] := articles[i].title;
      sgArticles.Cells[COLUMN_REASON,i+1] := articles[i].header;
      articles[i].relevanceRatingFromUser := 0;
      sgArticles.Cells[COLUMN_USER_RATING,i+1] := IntToStr(articles[i].relevanceRatingFromUser);
   end;
   showArticle(0);
end;

procedure TfrmMultiplePagesFound.RadioButton1Click(Sender: TObject);
begin
   if (not cellChanging) and (sgArticles.Row > 0) then
   begin
      articles[sgArticles.Row-1].relevanceRatingFromuser := getRelevance;
      sgArticles.Cells[COLUMN_USER_RATING,sgArticles.Row] := IntToStr(articles[sgArticles.Row-1].relevanceRatingFromuser);
   end;
end;

procedure TfrmMultiplePagesFound.sgArticlesSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
begin
   if ARow > 0 then
   begin
      showArticle(ARow-1);
   end;
end;


procedure TfrmMultiplePagesFound.showArticle(index: integer);
begin
   txtContents.Text := articles[index].description;
   linkLabel.Caption := articles[index].link;
   linkLabel.URL := articles[index].link;
   cellChanging := true;
   setRelevance(articles[index].relevanceRatingFromUser);
   cellChanging := false;
end;


function TfrmMultiplePagesFound.getRelevance: integer;
var
   i: integer;
   rb: TRadioButton;
begin
   for i := 0 to gbRelevance.ControlCount - 1 do
   begin
      if gbRelevance.Controls[i].ClassType = TRadioButton then
      begin
         rb := (gbRelevance.Controls[i] as TRadioButton);
         if rb.Checked then
         begin
            result := rb.Tag;
            exit;
         end;
      end;
   end;
   assert(false); // should never get here
end;

procedure TfrmMultiplePagesFound.setRelevance(relevance: integer);
var
   i: integer;
   rb: TRadioButton;
begin
   for i := 0 to gbRelevance.ControlCount - 1 do
   begin
      if gbRelevance.Controls[i].ClassType = TRadioButton then
      begin
         rb := (gbRelevance.Controls[i] as TRadioButton);
         if rb.tag = relevance then
         begin
            rb.Checked := true;
            exit;
         end;
      end;
   end;
   assert(false); // should never get here
end;

end.
